use async_trait::async_trait;
use serde_json::Value;
use std::error::Error;

// use serde_json::from_value()
// use int_enum::IntEnum;
use serde::{Deserialize, Serialize};
// use std::collections::HashMap;
// use std::future::Future;

pub type Result<T> = std::result::Result<T, Box<dyn Error>>;

//TODO: Vec<u8> or String.

pub trait ComChannel: Send + Sync {
   fn send_packet(&self, packet: String) -> Result<()>;
   fn read_packet(&self) -> Result<String>;
}

// TODO: Check what happens when error code is not included
// #[repr(i64)]
// #[derive(Clone, Copy, Debug, Eq, PartialEq, IntEnum, Deserialize, Serialize)]
// pub enum ErrorCodes {
//    ParseError = -32700,
//    InvalidRequest = -32600,
//    MethodNotFound = -32601,
//    InvalidParams = -32602,
//    InternalError = -32603,
// }

#[derive(Serialize, Deserialize)]
pub struct JRPCRequest {
   pub jsonrpc: String,
   pub id: Option<String>,
   pub method: String,
   pub params: Value,
}

#[derive(Serialize, Deserialize)]
pub struct JRPCError {
   pub code: i64,
   pub message: String,
   pub data: Value,
}

#[derive(Serialize, Deserialize)]
pub struct JRPCResult {
   pub jsonrpc: String,
   pub id: String,
   pub result: Value,
   pub error: Option<JRPCError>,
}
